###############################################################################
# IMPORTS

from  classlib.base import *
import Tkinter,tkMessageBox ,gui
#print 'GUI------------------------\n',dir()
###############################################################################

class Netedit_gui(Obj):
      def init_obj(self):
          self.gui_flag=1  # initialize ONLY in gui simulation mode

          if (not self.sim.objs.has_key(self.type))&\
             (self.sim.mode=='gui'):

                # initial control panel pointer
                #self.controlpanel=gui.Controlpanel(self)
                self.controlpanel=None
                self.objbrowser=None

                # create menues
                self.sim.menubar.addcascademenu('Edit', 'Modules',
                                                'Edit modules',
                                                #traverseSpec = 'z',
                                                tearoff = 1)

                self.sim.menubar.addmenuitem('Edit', 'command',\
                        'Browse and edit current simulation objects',
                                             command = self.browse_objs,
                                             label = 'Browse ...')

                
                
                
                # modules cascaded menues
                self.sim.menubar.addmenuitem('Modules', 'command',\
                        'Select a new module from browser and add to canvas',
                                             command = self.add_mod,
                                             label = 'Add ...')
                
                self.sim.menubar.addmenuitem('Modules', 'command',
                                             'Click on module to move',
                                             command = self.move_mod,
                                             label = 'Move')
                
                self.sim.menubar.addmenuitem('Modules', 'command',
                                             'Click on module to clone',
                                             command = self.clone_mod,
                                             label = 'Clone')
                
                self.sim.menubar.addmenuitem('Modules', 'command',
                                             'Click on module to delete',
                                             command = self.del_mod,
                                             label = 'Delete')

                self.sim.menubar.addmenuitem('Modules', 'command',
                                             'Click on module to activate',
                                             command = self.activate_mod,
                                             label = 'Activate')
                
                self.sim.menubar.addmenuitem('Modules', 'command',
                                    'Click on module to inactivate',
                                    command = self.inactivate_mod,
                                    label = 'Inactivate')

               
                
                self.sim.menubar.addmenuitem('Modules', 'command',
                      'Click on module to open control panel',
                                             command = self.controlpanel_mod,
                                             label = 'Control Panel')
                
                self.sim.menubar.addmenuitem('Modules', 'command',
                           'Click on module to show info on console',
                                    command = self.show_info,
                                    label = 'Show text info')
                
                self.sim.menubar.addmenuitem('Modules', 'separator')

                self.sim.menubar.addmenuitem('Modules', 'command',
                                             'Activates all modules',
                                             command = self.activate_all,
                                             label = 'Activate All')
                
                self.sim.menubar.addmenuitem('Modules', 'command',
                                             'Inactivates all modules',
                                             command = self.inactivate_all,
                                             label = 'Inactivate All')
                
                

                


                
                
      def close(self):
        """
        Does necessary action before this simulation object is
        deleted from memory.

        It can be assumed that the state of the object has been
        saved. So what remains is to clear up other things, essentially
        GUI stuff.
        """
        self.sim.menubar.deletemenu('Modules')

        
            
  
      #def reload(self):
      #      '''Reload all modules...does not work this way'''
      #      self.sim.reload_obj()

      def default(self,event=None):
        """
        Default function  that is called when
        no other action is specified.
        """
        if self.netmon:
              self.netmon.set_action('default')
              self.controlpanel_mod()
        
      
                  
      def activate_all(self):
            self.netmon.set_action('default')
            self.sim.activate_all()
            self.netmon.plot_track()
            #for sec in self.netsim.secs.values():
            #      #sec.elem.set_status('active')
            #      sec.elem.plot()
            # set next action
            self.default()
                  
      def inactivate_all(self):
            self.netmon.set_action('default')
            self.sim.inactivate_all()
            self.netmon.plot_track()
            #for sec in self.netsim.secs.values():
            #      #sec.elem.set_status('passive')
            #      sec.elem.plot()
            #
            # set next action
            self.default()

            
      def move_mod(self,event=None):
            
            self.netmon.set_action('move',
                                   callback_click = self.move_click,
                                   #callback_button2click=\
                                   #               self.activate_controlpanel,
                                   callback_rightclick=self.default,
                                   cursor='fleur')
            
      def move_click(self,event):
            self.netmon.set_action('move',
                                   callback_click = self.move_click,
                                   callback_button2click=self.move_click,
                                   callback_rightclick=self.default,
                                   cursor='fleur')
            
            obj, tag= self.netmon.find_obj(event)
            
            if tag:
                  if hasattr(obj,'move_gui'):
                        obj.move_gui(event,tag)

      def clone_mod(self,event=None):
            
            self.netmon.set_action('clone',
                                   callback_click = self.clone_click,
                                   callback_button2click=self.move_click,
                                   callback_rightclick=self.default,
                                   cursor='dotbox')
            
      def clone_click(self,event):
            
            obj, tag= self.netmon.find_obj(event)
            
            if tag:
                  if hasattr(obj,'clone_gui'):
                        obj.clone_gui(event,tag)
                  
      def controlpanel_mod(self,event=None):
            """
            Will activate/update the control panel when clicking
            on a module.
            """

            self.netmon.set_action('controlpanel',
                                   callback_click = self.activate_controlpanel,
                                   callback_motion = self.cp_motion,
                                   callback_doubleclick=self.move_click,
                                   callback_button2click=self.move_click,
                                   #callback_rightclick=self.move_mod,
                                   cursor='hand2')

      def cp_motion(self,event):
            """
            Called during motion when controlpanneled.
            Writes info on statusbar.
            """
            x,y=self.netmon.get_unmagnified_canvas_coords(event)

            self.sim.messagebar.message(
                        'userevent',
                        'Pointer position=%02dm,%02dm'%(x,y))
            
            

      def activate_controlpanel(self,event):
            """
            Will activate/update the control panel.
            """
            
            obj, tag= self.find_obj(event)
            #print 'activate_controlpanel on',tag
            if tag:
                  mod=self.sim.split_id(tag)['mod']
                  if hasattr(mod,'make_panel'):
                        if not self.controlpanel:
                              self.controlpanel=gui.Controlpanel(self,mod)
                        else:     
                              self.controlpanel.update_with_target(mod)
                  
      def close_controlpanel(self):
            """
            This method is called when  control panel called
            is about to close.
            """
            del self.controlpanel
            self.controlpanel=None


      def browse_objs(self):
            """
            Open/update browser window with current simulation objects
            """
            if not self.objbrowser:
                  self.objbrowser=gui.Objectbrowser(self)
            else:     
                  self.objbrowser.refresh()

      def close_objbrowser(self):
            """
            This method is called when objbrowser called
            is about to close.
            """
            del self.objbrowser
            self.objbrowser=None


            
      def add_mod(self):
            self.sim.configure_objectlibbrowser(\
                  callback_on_select=self.init_mod)

      
      def init_mod(self,type,multiselect_flag=0,mod=None):
          if self.debug>=5:
              print "init_mod: Type = "+type

          obj=self.sim.append_obj(type)

          if obj:
                if obj.multimod_flag:
                      if multiselect_flag:
                            if hasattr(obj,'multiadd_gui'):
                                  self.netmon.set_action('default')
                                  if self.debug>3:
                                        print 'Add new modules to sim object:'\
                                              +type
                                  try:
                                        # mod is here a prototype mod 
                                        obj.multiadd_gui(mod)
                                  except:
                                        print 'WARNING: Add of',type,'failed.'
                                        self.sim.remove_obj(obj)
                            else:
                                  self.sim.remove_obj(obj)
                                  
                      else:
                            if hasattr(obj,'add_gui'):
                                  self.netmon.set_action('default')
                                  if self.debug>3:
                                        print 'Add new module to sim object:'\
                                              +type
                                  try:
                                        obj.add_gui()
                                  except:
                                        print 'WARNING: Add of',type,'failed.'
                                        self.sim.remove_obj(obj)
                            else:
                                  self.sim.remove_obj(obj)
                            
          
          
      def del_mod(self):
            self.netmon.set_action('del',callback_click = self.del_click,
                                   callback_button2click=self.move_click,
                                   callback_rightclick=self.default,
                                   cursor='pirate')
            
      
      def del_click(self,event):
            obj, tag= self.find_obj(event)
            if tag:
                  if hasattr(obj,'del_gui'):
                        obj.del_gui(event,tag)

            
      def activate_mod(self):
            self.netmon.set_action('activate',
                                   callback_click = self.activate_click,
                                   callback_button2click=self.move_click,
                                   callback_rightclick=self.default,
                                   cursor='hand1')
      
      def activate_click(self,event):
            obj, tag= self.find_obj(event)
            if tag:
                  if hasattr(obj,'activate_gui'):
                        obj.activate_gui(event,tag)

              
      def inactivate_mod(self):
           self.netmon.set_action('inactivate',
                                  callback_click = self.inactivate_click,
                                  callback_button2click=self.move_click,
                                  callback_rightclick=self.default,
                                   cursor='hand1')
      
      def inactivate_click(self,event):
            obj, tag= self.find_obj(event)
            if tag:
                  if hasattr(obj,'inactivate_gui'):
                        obj.inactivate_gui(event,tag)


      def show_info(self):
            self.netmon.set_action('show_info',
                                   callback_click = self.show_info_click,
                                   callback_button2click=self.move_click,
                                   callback_rightclick=self.default,)
      
      def show_info_click(self,event):
            obj, tag= self.find_obj(event)
            if tag:
                  if hasattr(obj,'show_info'):
                        obj.show_info(event,tag)



      

      def find_obj(self,event):
            """
            Return object closest to the cursor-position.
            The returned tag is the tag near the pointer with
            the most detailled information i.e. if there is a part
            of the object then the tag of the part is returned.
            """
            return self.netmon.find_obj(event) 

      
      
            
      def link(self): # search if netmon is among the simulation objects
          self.netmon=self.try_link_with('base.net.netmon')
          

          self.netsim=self.try_link_with('base.net.netsim')
          if self.netmon:
                if self.netsim:
                      # set default action
                      #self.default()
                      self.netmon.set_defaultaction(self.default)
                      self.default()
