from classlib.track import *

class Merge_doublecurve(Track):

    def make_track(self):
        """
        This function sets essential parameters for the specific track
        element. It needs to be called once during initialization.
        """
        self.info= 'Merge track element where both input sections '+\
                   'are  circular curves.\n'+\
                   'Drag nodes to stretch output section or modify curve '+\
                   'radius.\n'+\
                   'Attention! The input lines must leave the carriers  '+\
                   'enough space to adapt their speed to those on the  '+\
                   'competing input line. Their length "l" must satisfy\n'+\
                   ' l > 0.5 * a * v^2 where "a" is maximum comfort'+\
                   ' decelleration and "v" the maximum line speed.'
        
        #straightbrach={'shape':( 'line', {'offset':(0,0,0), 'length':50}),
        #                'topo' : (1,2),
        #                }
        straightbrach={'shape': ( 'curve', {'offset':(50,0,0),
                                             'radius':50,
                                             'turn'  :'from_right'
                                             }),
                         'topo' : (1,2)
                         }  
        frombranch={'shape': ( 'curve', {'offset':(50,0,0),
                                             'radius':50,
                                             'turn'  :'from_left'
                                             }),
                     'topo' : (3,2)
                     }
        outline={'shape': ( 'line', {'offset':(50,0,0), 'length':50} ),
                   'topo' : (2,4),
                   }
        
        self.element=[straightbrach,frombranch,outline]
        self.nodes_connect={1:'in', 3:'in',4:'out'}
        self.Mod=Mergemod
